/* 

COPYRIGHT

     crypthisthing is my creation. It is freely given away to the public community in the hope that
     it will be useful, with no restrictions except giving credit where it is due. The author assumes
     NO responsibility for how anyone uses it. Comments, questions, and patches to juan@librenetwork.com

*/


#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <openssl/evp.h>

unsigned char key[17];
unsigned char *msg;
unsigned char *encryptedmsg;
int txtlen;

int encrypt_1(unsigned char *in, unsigned char *out, unsigned char *iv)
{
 EVP_CIPHER_CTX ctx;
 int outlen;
 int tmplen;
 EVP_CIPHER_CTX_init(&ctx);                                     /* initialize cipher */
 EVP_EncryptInit_ex(&ctx, EVP_bf_cbc(), NULL, key, iv); /* initialize cipher with blowfish encryption */
 printf("ENCRYPTING WITH %d BITS KEY", EVP_CIPHER_CTX_key_length(&ctx) * 8);
 EVP_EncryptUpdate(&ctx, out, &outlen, in,txtlen);              /* encrypt buffer */
 EVP_EncryptFinal_ex(&ctx, out + outlen, &tmplen);              /* encrypt remaining */
 EVP_CIPHER_CTX_cleanup(&ctx);
 return   outlen + tmplen;                                      /* return bytes encrypted */
}

int decrypt_1(unsigned char *in, unsigned char *out, unsigned char *iv)
{

 int outlen;
 int tmplen;
 EVP_CIPHER_CTX ctx;
 EVP_CIPHER_CTX_init(&ctx);                            /* initialize cipher */
 EVP_DecryptInit_ex(&ctx, EVP_bf_cbc(), NULL, key,iv); /* initialize cipher with blowfish decryption */
 EVP_DecryptUpdate(&ctx, out, &outlen, in, txtlen);    /* decrypt buffer */
 EVP_DecryptFinal_ex(&ctx, out + outlen, &tmplen);     /* decrypt remaining */
 EVP_CIPHER_CTX_cleanup(&ctx);
 return  tmplen + outlen;                              /* return bytes decrypted */
}

int sizeofile(FILE *fd) 
{


      /* 
         Count bytes on a given FILE stream.
         On error, it returns -1 with with errno set. 
         Otherwise, it returns the bytes read.
      */

      long len;

      if( (fseek(fd,0L,SEEK_END)) != -1) 
      {
         len = ftell(fd);

         if( (fseek(fd,0L,SEEK_SET)) == -1) 
         {
            len = -1;
         }

      }

      else 
      {
        len=-1;
      }

      return (int) len;


}

char * replacename(char *buffer) {
   int i=0;
   int len = (int) strlen(buffer);
   while (buffer[i]) 
   {
      if(i == (len - 1))
      if(buffer[i] == 't' && buffer[i-1] == 'r' && buffer[i-2] == 'c' && buffer[i-3] == '.') {
           buffer[i-3] = '\0'; 

      }
      ++i;
   }
   return buffer;
}

int main (int argc, char **argv)
{
  int decrypt_1(unsigned char *in, unsigned char *out, unsigned char *iv);
  int encrypt_1(unsigned char *in, unsigned char *out, unsigned char *iv);
  char *replacename(char *);
  int sizeofile(FILE *fd); 
  int keylen;
  int ivlen;
  char cipherfile[50];
  unsigned char iv[11];
  FILE *fd;
  FILE *clear_data_fd;

  if(argc == 5){
  if(!(strcmp(argv[1],"write")))
  {
      if(argc==5) {

      if(!(clear_data_fd = fopen(argv[2],"rb"))) {
        perror("ERROR");
        exit(EXIT_FAILURE);
      }

      if((txtlen = sizeofile(clear_data_fd)) == -1) {
        perror("ERROR2");
        exit(EXIT_FAILURE);
      }

      msg = (unsigned char *) malloc( sizeof(unsigned char) * ((long unsigned int) txtlen) + 10);
      encryptedmsg = (unsigned char *) malloc(sizeof(unsigned char) * ((long unsigned int) txtlen) + 64);

      memset(msg,0,(size_t) txtlen + 10);
      memset(encryptedmsg,0,(size_t) txtlen + 64);

      fread(msg,1,(size_t) txtlen,clear_data_fd);

      if( (ferror(clear_data_fd)) ) 
      {
         perror("ERROR");
         free(msg);
         free(encryptedmsg);
         exit(EXIT_FAILURE);
      }

      fclose(clear_data_fd);
      cipherfile[0] = '\0';
      strncat(cipherfile,argv[2],30);
      strcat(cipherfile,".crt");

      if(!(fd = fopen(cipherfile,"wb"))) {
           perror("ERROR");
           free(msg);
           free(encryptedmsg);
           exit(EXIT_FAILURE);	
      }

      memmove(key,argv[3],16);
      memmove(iv,argv[4],10);

      keylen =  (int) strlen(argv[3]);
      ivlen  =  (int) strlen(argv[4]);

      if(keylen<=16 && ivlen<=10) {
        key[keylen]=0;
        iv[ivlen]=0;
      }

      else {
        free(msg);
	free(encryptedmsg);
	fprintf(stderr,"ERROR: max keylen is 16 bytes & max ivlen is 10 bytes\n");
	exit(EXIT_FAILURE);
      }

      fwrite(encryptedmsg,sizeof(unsigned char), (size_t) encrypt_1(msg,encryptedmsg,iv),fd);

      if((ferror(fd))) 
      {
         perror("ERROR");
         free(msg);
         free(encryptedmsg);
         exit(EXIT_FAILURE);
      }

      fclose(fd);
      printf("\nENTERED FILE: %s\nENTERED KEY: %s\nENTERED IV: %s\nCIPHER FILE: %s\n",argv[2],argv[3],argv[4],cipherfile);
      free(msg);
      free(encryptedmsg);

      }

      else { 
        printf("usage: %s {read filename key | write filename key}\n",argv[0]); 
      }

 }

 else if(!(strcmp(argv[1],"read"))) {

    if (argc == 5) {

       memset(cipherfile,0,30);

       strncat(cipherfile,argv[2],30);

       if(!(fd = fopen(cipherfile,"rb"))) {
         perror("ERROR");
         exit(EXIT_FAILURE);
       }

       memmove(key,argv[3],16);
       memmove(iv,argv[4],10);
       keylen = (int) strlen(argv[3]);
       ivlen = (int) strlen(argv[4]);

       if(keylen <= 16 && ivlen <= 10) {
          key[keylen]=0;
          iv[ivlen]=0;
       }

       else {
          fprintf(stderr,"ERROR: max keylen is 16 bytes & max ivlen is 10 bytes\n");
   	  exit(EXIT_FAILURE);
       }

       if( ( txtlen=sizeofile(fd) ) == -1) {
         perror("ERROR2");
         exit(EXIT_FAILURE);
       }

       msg = (unsigned char *) malloc(sizeof(unsigned char) * ((long unsigned int) txtlen+64));
       encryptedmsg = (unsigned char *) malloc(sizeof(unsigned char) * ((long unsigned int) txtlen+100));

       memset(msg,0,(size_t) txtlen + 64);
       memset(encryptedmsg,0,(size_t) txtlen + 100);

       fread(encryptedmsg,1,(size_t)txtlen,fd);

       if( (ferror(fd)) ) {
         perror("ERROR3");
         exit(EXIT_FAILURE);
       }

       
       txtlen = decrypt_1(encryptedmsg,msg,iv);

       fclose(fd);

       replacename(cipherfile); /* substitude 'file.jpg.crt' for 'file.jpg' if there is a .crt on the filename */

       if(!(fd = fopen(cipherfile,"wb"))) 
       {
           perror("ERROR");
           free(msg);
           free(encryptedmsg);
           exit(EXIT_FAILURE);	
       }

       fwrite(msg,1,(size_t)txtlen,fd);

       if((ferror(fd))) 
       {
         perror("ERROR");
         free(msg);
         free(encryptedmsg);
         exit(EXIT_FAILURE);
       }

       printf("ENCRYPTED '%s' FILE IS CLEARED TO FILE: '%s'\n",argv[2],cipherfile);
       fclose(fd);
   }

   else 
   {
     printf("usage: %s {read filename key iv | write filename key iv}\n",argv[0]); 
   }

  } 
  else { 
    printf("usage: %s {read filename key iv | write filename key iv}\n",argv[0]);  
  }}

 else { 
   printf("usage: %s {read filename key iv | write filename key iv}\n",argv[0]); 
 } 

  return 0;

}
